import Scene from "../views/Scene";
import MyImage from "./MyImage";
import PanelCtrl from "../ctrls/panelCtrl";
import { ModuleTypes } from "../types/sceneTypes";
import { NetManager } from "../../libs/tw/manager/NetManager";
import { DataManager } from "../../libs/tw/manager/DataManager";
import { GTime } from "../../libs/tc/util/GTime";
import { TimeFormat } from "../../libs/tc/enum/TimeFormat";
import Panel from "../views/Panel";
import { GDispatcher } from "../../libs/tc/util/GDispatcher";
import { Buried } from "../../libs/tw/util/Buried";
import ComponentBase from "../components/ComponentBase";
import GuidePanel from "../guidePanel/GuidePanel";
import { GCache } from "../../libs/tc/util/GCache";
import Loading from "../loading/Loading";
import { GetPrizeInfoData } from "../../libs/tw/data/plug/getPrizeInfo/GetPrizeInfoData";
import { ABNetManager } from "../../libs/tc/manager/ABNetManager";
import FriendItem from "./FriendItem";
import { NetName } from "../../libs/tw/enum/NetName";
import DogItem from "./DogItem";
import DataConversion from "./DataConversion";

export default class MainScene extends Scene {

	public topGroup:eui.Group;
	public lvText:eui.Label;
	public foodCountText:eui.Label;
	public teamCountText:eui.Label;
	public yieldRateText:eui.Label;
	public team_0:eui.Group;
	public team_1:eui.Group;
	public team_2:eui.Group;
	public team_3:eui.Group;
	public team_4:eui.Group;
	public team_5:eui.Group;
	public bottomGroup:eui.Group;
	public addDogBtn:eui.Button;
	public doglist_0:eui.Group;
	public doglist_1:eui.Group;
	public doglist_2:eui.Group;
	public doglist_3:eui.Group;
	public doglist_4:eui.Group;
	public doglist_5:eui.Group;
	public doglist_6:eui.Group;
	public doglist_7:eui.Group;
	public doglist_8:eui.Group;
	public doglist_9:eui.Group;
	public doglist_10:eui.Group;
	public doglist_11:eui.Group;



	/* private dogLvLists=[

	]
 */
	private dogLvLists = [
		"小奶狗",
		"小白狗",
		"小黑狗",
		"小狼狗",
		"金毛",
		"柯基",
		"柴犬",
		"博美",
		"泰迪",
		"巴哥犬",
		"比熊",
		"雪纳瑞",
		"秋田犬",
		"萨摩耶",
		"贵宾犬",
		"边境牧羊犬",
		"拉布拉多",
		"哈士奇",
		"吉娃娃",
		"法国斗牛犬",
		"牛头梗",
		"蝴蝶犬",
		"杜宾",
		"松狮",
		"茶杯犬",
		"苏格兰牧羊犬",
		"英国玩具犬",
		"迦南犬",
		"阿拉斯加雪橇犬",
		"阿富汗猎犬",
	]


	public get skinKey() { return 'MainScene' }
	public get groupName() { return 'main_scene' }

	private teams = [];
	private doglists = [];
	constructor(data?) {
		super(data);
		if (data) {

		}
		this.percentHeight = 100;
	}

	initEvents() {
		GDispatcher.addEvent(ABNetManager.ERROR, this.onError, this);

		
		this.addDogBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTap_addDogBtn, this);


		for (let i = 0; i < 6; i++) {
			this.teams[i] = new FriendItem()
			this.teams[i].x = 0;
			this.teams[i].y = 0;
			this["team_" + i].addChild(this.teams[i])
			/* this.teams[i].setLoadVal(50)
			this.teams[i].setState(true) */
		}

		for (let i = 0; i < 12; i++) {
			this.doglists[i] = new DogItem()
			this.doglists[i].x = -8;
			this.doglists[i].y = -60;
			this["doglist_" + i].addChild(this.doglists[i])
		}
		setInterval(this.updateIncome.bind(this),3000)
	}

	//更新收入+增加积分
	updateIncome(){
		this.dogRate()
	}


	onTap_addDogBtn(){
		this.enabled=false;
		NetManager.ins.getSummon((succuss) => {
			
			if (!succuss) {
				this.enabled=true;
				return;
			}
			NetManager.ins.getHome((succuss) => {
				this.enabled=true;
				if (!succuss) {
					return;
				}
				this.updateIndex(true)
			}, "","")
			//alert()
			
		},this.homeData.summonLevel,"")
	}

	private onError(net: any, code: any): void {
		console.log(code);
		var msg: string;
		var msgArr: any = window['errorMessage'];
		if (!isNaN(code)) {
			msg = msgArr[code] ? msgArr[code] : '额哦，一个未知的错误';
		} else {
			msg = code;
		}

		PanelCtrl.instance.show(ModuleTypes.MSG_PANEL, [msg], false);
	}
	removeEvents() {
		this.removeEventListener(egret.Event.ENTER_FRAME, this.onEnterFrame, this);
		this.addDogBtn.removeEventListener(egret.TouchEvent.TOUCH_TAP, this.onTap_addDogBtn, this);
		GDispatcher.removeEvent(ABNetManager.ERROR, this.onError, this);
	}

	protected onSkinComplete(): void {
		super.onSkinComplete();
		NetManager.ins.getHome((succuss) => {
			if (!succuss) {
				return;
			}
			this.updateIndex()
		}, "","")
	}

	//home数据
	homeData
	//组队数据
	teamData
	//狗狗列表输数据
	dogData

	updateIndex(state?) {
		console.log(DataManager.ins.getData(NetName.GET_HOME))
		this.homeData = DataManager.ins.getData(NetName.GET_HOME).data;
		if (this.homeData) {
			this.teamData = this.homeData.team
			this.dogData = this.homeData.dogs
			this.updateTeam()
			if(state){
				//如果state是真，则对最后一名效果添加入场动画
				this.updateDogList(true)
			}else{
				this.updateDogList(false)
			}
			
			this.updateAllTextFromHome()
		}
	}

	//最大等级
	maxLevel=0
	//生产速率
	yieldRate=0
	//粮食库存
	foodStocks=0

	updateAllTextFromHome() {
		if(this.homeData.maxLevel){
			this.maxLevel=this.homeData.maxLevel;
			this.lvText.text = `LV.${this.maxLevel}${this.dogLvLists[this.maxLevel-1]}`
		}

		if(this.homeData.yieldRate){
			this.yieldRate=this.homeData.yieldRate;
			this.yieldRateText.text = `+${DataConversion.doConversion(this.yieldRate)}/秒`
		}

		if(this.homeData.foodStocks){
			this.foodStocks=this.homeData.foodStocks
			this.foodCountText.text = `${DataConversion.doConversion(this.foodStocks)}`
		}

		if(this.homeData.team){
			this.teamCountText.text = `${this.homeData.team.length}人`
		}

		if(this.homeData.team){
			this.teamCountText.text = `${this.homeData.team.length}人`
		}

		if(this.homeData.summonConsume&&this.homeData.summonLevel){
			this.addDogBtn.label=`LV.${this.homeData.summonLevel}消耗${DataConversion.doConversion(this.homeData.summonConsume)}狗粮`
		}
	}

	updateAllTextFromLocalCount() {
		this.lvText.text = `LV.${this.maxLevel}${this.dogLvLists[this.maxLevel-1]}`
		this.yieldRateText.text = `+${DataConversion.doConversion(this.yieldRate)}/秒`
		this.foodCountText.text = `${DataConversion.doConversion(this.foodStocks)}`
	}


	updateTeam() {
		for (let i = 0; i < 6; i++) {
			if (this.teamData[i]) {
				this.teams[i].setLoadVal((24 * 60 - this.teamData[i].remainingTime) / (24 * 60) * 100)
				this.teams[i].setState(true)
				this.teams[i].setImgUrl(this.teamData[i].avatar)
			} else {
				this.teams[i].setState(false)
			}
		}
	}

	positionCatchs=[]

	updateDogList(state) {
		if(localStorage.positionCatchs){
			this.positionCatchs=JSON.parse(localStorage.positionCatchs)
		}else{
			this.positionCatchs=[]
		}
		
		/* for (let i = 0; i < 12; i++) {
			
		} */
		for (let i = 0; i < 12; i++) {
			this.doglists[i].visible=false
			if (this.dogData[i]) {
				this.doglists[i].visible=true;
				this.doglists[i].setLv(this.dogData[i].level)
				this.doglists[i].setRate(`${DataConversion.doConversion(this.dogData[i].rate*3)}`)
				if(!localStorage.positionCatchs){
					this.positionCatchs.push({level:this.dogData[i].level,index:i})
				}
			}else{
				if(!localStorage.positionCatchs){
					this.positionCatchs.push({level:0,index:i})
				}
			}
		}
		if(state){
			this.doglists[this.dogData.length - 1].firstAn()
		}
		//else{
			localStorage.positionCatchs=JSON.stringify(this.positionCatchs)
		//}
		/* console.log(this.positionCatchs)
		localStorage.positionCatchs=JSON.stringify(this.positionCatchs) */
		console.log(JSON.parse(localStorage.positionCatchs))
		this.dataCheck()
	}


	catchCount=[];
	dataCount=[];

	dataCheck(){
		this.catchCount=[];
		this.dataCount=[];

		for(let i=0;i<this.dogData.length;i++){
			let data=this.dogData[i]
			if(this.dataCount[data.level]==undefined&&this.dataCount[data.level]==null){
				this.dataCount[data.level]=1;
			}else{
				this.dataCount[data.level]++;
			}
		}

		for(let i=0;i<this.positionCatchs.length;i++){
			let data=this.positionCatchs[i]
			if(this.catchCount[data.level]==undefined&&this.catchCount[data.level]==null){
				if(data.level!=0){
					this.catchCount[data.level]=1;
				}
			}else{
				if(data.level!=0){
					this.catchCount[data.level]++;
				}
			}
		}


		console.log(this.dataCount)
		console.log(this.catchCount)

		console.log(this.isSame(this.dataCount,this.catchCount))
		
		/* this.dataCount.forEach((data,i)=>{
			console.log(i+"_"+data)
		}) */

		/* this.catchCount.forEach((data,i)=>{
			console.log(i+"_"+data)
		}) */
		
	}

	isSame(val1,val2){
		if(val1.length!=val2.length){
			return false
		}
		var state=1
		for(let i=0;i<val1.length;i++){
			console.log(i+"_"+val1[i])
			if(val1[i]&val2[i]&&val1[i]==val2[i]){}else{
				state=2
			}
		}
		if(state==1){
			return true
		}else{
			return false;
		}
	}


	//狗狗产量气泡
	dogRate(){
		for (let i = 0; i < 12; i++) {
			if (this.dogData[i]) {
				//this.doglists[i].addGold()
				this.addGold(i)
			}
		}
	}

	addGold(i){
		setTimeout(()=>{
			    this.foodStocks+=(this.dogData[i].rate*3);
				this.doglists[i].addGold()
				this["foodUpdate"].play(0)
				this.updateAllTextFromLocalCount()
		},1400*Math.random())
	}



	start(data?) {

	}

	protected onLoad(): void {
		this.initUI();

		this.addEventListener(egret.Event.ENTER_FRAME, this.onEnterFrame, this);
	}

	private initUI(): void {
		//初始化数据
		this.initData();

	}
	private initData(): void {
	}


	private onEnterFrame(): void {

	}

}